angular.module('gaugesScreen', [])

  .controller('GaugesScreenController', function ($scope, $element, $window) {
    "use strict";
    var vm = this;

    var svg;
    var navContainer = $element[0].children[0];
    var navDimensions = [];

    var gauge = { gears: {} };
    var tacho = {  };
    var infoDisplay = {};
    var roots = {};
    var electrics = {lights:{} };
    var gagues = {fuel:{},temp:{}};


    var speedoInitialised = true;
    var currentGear = '';

    var ready = false;

    var unit = "metric";
    var unitspeedConv = 3.6;
    // mph = 2.23694
    // kmh = 3.6


    // Make sure SVG is loaded
    $scope.onSVGLoaded = function () {
        console.log("onSVGLoaded");
      svg = $element[0].children[0].children[0];


      gauge.speedValue = hu('#speedValue', svg);
      gauge.tachoValue = hu('#rpm', svg);
      gauge.tempValue = hu('#temp_text', svg);
      gauge.fuelValue = hu('#fuel_text', svg);

      gauge.bieg = hu('#bieg', svg);

      gauge.clock = hu('#clock_hour_txt', svg);
	  
      roots.speedo_bar = hu('#speedo_bar', svg);
      roots.tacho_bar = hu('#tacho_bar', svg);
      roots.fuel_bar = hu('#fuel_bar', svg);
      roots.temp_bar = hu('#temp_bar', svg);
      roots.oil_bar = hu('#oil_bar', svg);
      roots.battery_bar = hu('#battery_bar', svg);


      electrics.lights.battery = hu('#lights_battery', svg);	
      electrics.lights.parkingbrake = hu("#light_parkingbrake", svg);	 
      electrics.lights.checkengine = hu('#light_checkengine', svg);
      electrics.lights.signal_L = hu('#light_signal_L', svg);
      electrics.lights.signal_R = hu('#light_signal_R', svg);
      electrics.lights.lowbeam = hu("#light_lowbeam", svg);
      electrics.lights.highbeam = hu("#light_highbeam", svg);

      electrics.rpm0 = hu("#tacho_bar_0", electrics.root);
      electrics.rpm1 = hu("#tacho_bar_1", electrics.root);
      electrics.rpm2 = hu("#tacho_bar_2", electrics.root);
      electrics.rpm3 = hu("#tacho_bar_3", electrics.root);
      electrics.rpm4 = hu("#tacho_bar_4", electrics.root);
      electrics.rpm5 = hu("#tacho_bar_5", electrics.root);
      electrics.rpm6 = hu("#tacho_bar_6", electrics.root);
      electrics.rpm7 = hu("#tacho_bar_7", electrics.root);
      electrics.rpm8 = hu("#tacho_bar_8", electrics.root);
      electrics.rpm9 = hu("#tacho_bar_9", electrics.root);
      electrics.rpm10 = hu("#tacho_bar_10", electrics.root);
      electrics.rpm11 = hu("#tacho_bar_11", electrics.root);
      electrics.rpm12 = hu("#tacho_bar_12", electrics.root);
      electrics.rpm13 = hu("#tacho_bar_13", electrics.root);
      electrics.rpm14 = hu("#tacho_bar_14", electrics.root);
      electrics.rpm15 = hu("#tacho_bar_15", electrics.root);
      electrics.rpm16 = hu("#tacho_bar_16", electrics.root);
      electrics.rpm17 = hu("#tacho_bar_17", electrics.root);
      electrics.rpm18 = hu("#tacho_bar_18", electrics.root);
      electrics.rpm19 = hu("#tacho_bar_19", electrics.root);
      electrics.rpm20 = hu("#tacho_bar_20", electrics.root);
      electrics.rpm21 = hu("#tacho_bar_21", electrics.root);
      electrics.rpm22 = hu("#tacho_bar_22", electrics.root);
      electrics.rpm23 = hu("#tacho_bar_23", electrics.root);
      electrics.rpm24 = hu("#tacho_bar_24", electrics.root);
      electrics.rpm25 = hu("#tacho_bar_25", electrics.root);
      electrics.rpm26 = hu("#tacho_bar_26", electrics.root);
      electrics.rpm27 = hu("#tacho_bar_27", electrics.root);
      electrics.rpm28 = hu("#tacho_bar_28", electrics.root);
      electrics.rpm29 = hu("#tacho_bar_29", electrics.root);
      electrics.rpm30 = hu("#tacho_bar_30", electrics.root);
      electrics.rpm31 = hu("#tacho_bar_31", electrics.root);
	  
      electrics.woda0 = hu("#temp_bar_0", electrics.root);
      electrics.woda1 = hu("#temp_bar_1", electrics.root);
      electrics.woda2 = hu("#temp_bar_2", electrics.root);
      electrics.woda3 = hu("#temp_bar_3", electrics.root);
      electrics.woda4 = hu("#temp_bar_4", electrics.root);
      electrics.woda5 = hu("#temp_bar_5", electrics.root);
      
      electrics.paliwo0 = hu("#fuel_bar_0", electrics.root);
      electrics.paliwo1 = hu("#fuel_bar_1", electrics.root);
      electrics.paliwo2 = hu("#fuel_bar_2", electrics.root);
      electrics.paliwo3 = hu("#fuel_bar_3", electrics.root);
      electrics.paliwo4 = hu("#fuel_bar_4", electrics.root);
      electrics.paliwo5 = hu("#fuel_bar_5", electrics.root);
      electrics.paliwo6 = hu("#fuel_bar_6", electrics.root);
      electrics.paliwo7 = hu("#fuel_bar_7", electrics.root);
      electrics.paliwo8 = hu("#fuel_bar_8", electrics.root);
      electrics.paliwo9 = hu("#fuel_bar_9", electrics.root);
	  
	  
	  
      electrics.speedo0 = hu("#speedo_bar0", electrics.root);
      electrics.speedo1 = hu("#speedo_bar1", electrics.root);
      electrics.speedo2 = hu("#speedo_bar2", electrics.root);
      electrics.speedo3 = hu("#speedo_bar3", electrics.root);
      electrics.speedo4 = hu("#speedo_bar4", electrics.root);
      electrics.speedo5 = hu("#speedo_bar5", electrics.root);
      electrics.speedo6 = hu("#speedo_bar6", electrics.root);
      electrics.speedo7 = hu("#speedo_bar7", electrics.root);
      electrics.speedo8 = hu("#speedo_bar8", electrics.root);
      electrics.speedo9 = hu("#speedo_bar9", electrics.root);
      electrics.speedo10 = hu("#speedo_bar10", electrics.root);
      electrics.speedo11 = hu("#speedo_bar11", electrics.root);
      electrics.speedo12 = hu("#speedo_bar12", electrics.root);
      electrics.speedo13 = hu("#speedo_bar13", electrics.root);
      electrics.speedo14 = hu("#speedo_bar14", electrics.root);
      electrics.speedo15 = hu("#speedo_bar15", electrics.root);
      electrics.speedo16 = hu("#speedo_bar16", electrics.root);
      electrics.speedo17 = hu("#speedo_bar17", electrics.root);
      electrics.speedo18 = hu("#speedo_bar18", electrics.root);
      electrics.speedo19 = hu("#speedo_bar19", electrics.root);
      electrics.speedo20 = hu("#speedo_bar20", electrics.root);
      electrics.speedo21 = hu("#speedo_bar21", electrics.root);
      electrics.speedo22 = hu("#speedo_bar22", electrics.root);
      electrics.speedo23 = hu("#speedo_bar23", electrics.root);
      electrics.speedo24 = hu("#speedo_bar24", electrics.root);
      electrics.speedo25 = hu("#speedo_bar25", electrics.root);
      electrics.speedo26 = hu("#speedo_bar26", electrics.root);
      electrics.speedo27 = hu("#speedo_bar27", electrics.root);
      electrics.speedo28 = hu("#speedo_bar28", electrics.root);
      electrics.speedo29 = hu("#speedo_bar29", electrics.root);
      electrics.speedo30 = hu("#speedo_bar30", electrics.root);
      electrics.speedo31 = hu("#speedo_bar31", electrics.root);
      electrics.speedo32 = hu("#speedo_bar32", electrics.root);
      electrics.speedo33 = hu("#speedo_bar33", electrics.root);
      electrics.speedo34 = hu("#speedo_bar34", electrics.root);
      electrics.speedo35 = hu("#speedo_bar35", electrics.root);
      electrics.speedo36 = hu("#speedo_bar36", electrics.root);
      electrics.speedo37 = hu("#speedo_bar37", electrics.root);
      electrics.speedo38 = hu("#speedo_bar38", electrics.root);
      electrics.speedo39 = hu("#speedo_bar39", electrics.root);
      electrics.speedo40 = hu("#speedo_bar40", electrics.root);
      electrics.speedo41 = hu("#speedo_bar41", electrics.root);
      electrics.speedo42 = hu("#speedo_bar42", electrics.root);
      electrics.speedo43 = hu("#speedo_bar43", electrics.root);

      ready = true;
    }

    function updateTachoDisplays(data) {
      let rpm = Math.round(data["electrics"]["rpmTacho"]/10 )*10
      gauge.tachoValue.text(rpm);

      if(rpm<=250) { electrics.rpm0.css({fill:'black'}); } else { electrics.rpm0.css({fill:'white'}); }
      if(rpm<=500) { electrics.rpm1.css({fill:'black'}); } else { electrics.rpm1.css({fill:'white'}); }
      if(rpm<=750) { electrics.rpm2.css({fill:'black'}); } else { electrics.rpm2.css({fill:'white'}); }
      if(rpm<=1000) { electrics.rpm3.css({fill:'black'}); } else { electrics.rpm3.css({fill:'white'}); }
      if(rpm<=1250) { electrics.rpm4.css({fill:'black'}); } else { electrics.rpm4.css({fill:'white'}); }
      if(rpm<=1500) { electrics.rpm5.css({fill:'black'}); } else { electrics.rpm5.css({fill:'white'}); }
      if(rpm<=1750) { electrics.rpm6.css({fill:'black'}); } else { electrics.rpm6.css({fill:'white'}); }
      if(rpm<=2000) { electrics.rpm7.css({fill:'black'}); } else { electrics.rpm7.css({fill:'white'}); }
      if(rpm<=2250) { electrics.rpm8.css({fill:'black'}); } else { electrics.rpm8.css({fill:'white'}); }
      if(rpm<=2500) { electrics.rpm9.css({fill:'black'}); } else { electrics.rpm9.css({fill:'white'}); }
      if(rpm<=2750) { electrics.rpm10.css({fill:'black'}); } else { electrics.rpm10.css({fill:'white'}); }
      if(rpm<=3000) { electrics.rpm11.css({fill:'black'}); } else { electrics.rpm11.css({fill:'white'}); }
      if(rpm<=3250) { electrics.rpm12.css({fill:'black'}); } else { electrics.rpm12.css({fill:'white'}); }
      if(rpm<=3500) { electrics.rpm13.css({fill:'black'}); } else { electrics.rpm13.css({fill:'white'}); }
      if(rpm<=3750) { electrics.rpm14.css({fill:'black'}); } else { electrics.rpm14.css({fill:'white'}); }
      if(rpm<=4000) { electrics.rpm15.css({fill:'black'}); } else { electrics.rpm15.css({fill:'white'}); }
      if(rpm<=4250) { electrics.rpm16.css({fill:'black'}); } else { electrics.rpm16.css({fill:'white'}); }
      if(rpm<=4500) { electrics.rpm17.css({fill:'black'}); } else { electrics.rpm17.css({fill:'white'}); }
      if(rpm<=4750) { electrics.rpm18.css({fill:'black'}); } else { electrics.rpm18.css({fill:'white'}); }
      if(rpm<=5000) { electrics.rpm19.css({fill:'black'}); } else { electrics.rpm19.css({fill:'white'}); }
      if(rpm<=5250) { electrics.rpm20.css({fill:'black'}); } else { electrics.rpm20.css({fill:'white'}); }
      if(rpm<=5500) { electrics.rpm21.css({fill:'black'}); } else { electrics.rpm21.css({fill:'white'}); }
      if(rpm<=5750) { electrics.rpm22.css({fill:'black'}); } else { electrics.rpm22.css({fill:'white'}); }
      if(rpm<=6000) { electrics.rpm23.css({fill:'transparent'}); } else { electrics.rpm23.css({fill:'orange'}); }
      if(rpm<=6250) { electrics.rpm24.css({fill:'transparent'}); } else { electrics.rpm24.css({fill:'orange'}); }
      if(rpm<=6500) { electrics.rpm25.css({fill:'transparent'}); } else { electrics.rpm25.css({fill:'orange'}); }
      if(rpm<=6750) { electrics.rpm26.css({fill:'transparent'}); } else { electrics.rpm26.css({fill:'orange'}); }
      if(rpm<=7000) { electrics.rpm27.css({fill:'transparent'}); } else { electrics.rpm27.css({fill:'orange'}); }
      if(rpm<=7250) { electrics.rpm28.css({fill:'transparent'}); } else { electrics.rpm28.css({fill:'orange'}); }
      if(rpm<=7500) { electrics.rpm29.css({fill:'transparent'}); } else { electrics.rpm29.css({fill:'orange'}); }
      if(rpm<=7900) { electrics.rpm30.css({fill:'transparent'}); } else { electrics.rpm30.css({fill:'red'}); }
      if(rpm<=8400) { electrics.rpm31.css({fill:'transparent'}); } else { electrics.rpm31.css({fill:'red'}); }
    }
    function updateSpeedDisplays(data) {
      let speed = data.electrics.wheelspeed * unitspeedConv
      gauge.speedValue.text((speed).toFixed(0));
    }

    function updateSignalsDisplay(data) {
		let signal_L = data.electrics.signal_L;
		let signal_R = data.electrics.signal_R;

		if(signal_L==1) { electrics.lights.signal_L.css({fill:'green'}); } else { electrics.lights.signal_L.css({fill:'black'}); }
		if(signal_R==1) { electrics.lights.signal_R.css({fill:'green'}); } else { electrics.lights.signal_R.css({fill:'black'}); }
    }

    function updateIndicatorLightsDisplay(data) {
		electrics.lights.battery.n.style.display = (data.electrics.engineRunning<0.1)?"inline":"none";
		electrics.lights.parkingbrake.n.style.display = (data.electrics.parkingbrake>0.1)?"inline":"none";
		electrics.lights.checkengine.n.style.display = (data.electrics.checkengine)?"inline":"none";
		electrics.lights.lowbeam.n.style.display = (data.electrics.lights >= 0.6)?"inline":"none";
		electrics.lights.highbeam.n.style.display = (data.electrics.lights > 1)?"inline":"none";
    }


    function updateBiegDisplays(data) {
      let bieg = data.electrics.gear
	  if(bieg==0) {bieg='N';}
	  if(bieg<=0) {bieg='R';}
      gauge.bieg.text((bieg));
    }

    function updateGagueFuel(data) {
      let paliwo = data.electrics.fuel;
      let paliwo2 = paliwo*100;
      let paliwozao=paliwo2.toFixed(1);

      if(paliwo2<=1) { electrics.paliwo0.css({fill:'black'}); } else if(paliwo2<=10) { electrics.paliwo0.css({fill:'red'}); } else { electrics.paliwo0.css({fill:'white'}); }
      if(paliwo2<=10) { electrics.paliwo1.css({fill:'black'}); } else { electrics.paliwo1.css({fill:'white'}); }
      if(paliwo2<=20) { electrics.paliwo2.css({fill:'black'}); } else { electrics.paliwo2.css({fill:'white'}); }
      if(paliwo2<=30) { electrics.paliwo3.css({fill:'black'}); } else { electrics.paliwo3.css({fill:'white'}); }
      if(paliwo2<=40) { electrics.paliwo4.css({fill:'black'}); } else { electrics.paliwo4.css({fill:'white'}); }
      if(paliwo2<=50) { electrics.paliwo5.css({fill:'black'}); } else { electrics.paliwo5.css({fill:'white'}); }
      if(paliwo2<=60) { electrics.paliwo6.css({fill:'black'}); } else { electrics.paliwo6.css({fill:'white'}); }
      if(paliwo2<=70) { electrics.paliwo7.css({fill:'black'}); } else { electrics.paliwo7.css({fill:'white'}); }
      if(paliwo2<=80) { electrics.paliwo8.css({fill:'black'}); } else { electrics.paliwo8.css({fill:'white'}); }
      if(paliwo2<=90) { electrics.paliwo9.css({fill:'black'}); } else { electrics.paliwo9.css({fill:'white'}); }
	  }

    function updateGagueTempDisplays(data) {
      let woda = data.electrics.watertemp;
      let wodazao=Math.floor(woda);
      gauge.tempValue = wodazao + "°C";
      if(woda<=20) { electrics.woda0.css({fill:'black'}); } else { electrics.woda0.css({fill:'white'}); }
      if(woda<=50) { electrics.woda1.css({fill:'black'}); } else { electrics.woda1.css({fill:'white'}); }
      if(woda<=80) { electrics.woda2.css({fill:'black'}); } else { electrics.woda2.css({fill:'white'}); }
      if(woda<=100) { electrics.woda3.css({fill:'black'}); } else { electrics.woda3.css({fill:'white'}); }
      if(woda<=120) { electrics.woda4.css({fill:'transparent'}); } else { electrics.woda4.css({fill:'red'}); }
	  }

    function updateSpeedoDisplays(data) {	  
		let speedo = data.electrics.wheelspeed * unitspeedConv;
		//console.log("speedo:");
		if(speedo<=8) { electrics.speedo0.css({fill:'transparent'}); } else { electrics.speedo0.css({fill:'white'}); }
		if(speedo<=8*2) { electrics.speedo1.css({fill:'transparent'}); } else { electrics.speedo1.css({fill:'white'}); }
		if(speedo<=24) { electrics.speedo2.css({fill:'transparent'}); } else { electrics.speedo2.css({fill:'white'}); }
		if(speedo<=32) { electrics.speedo3.css({fill:'transparent'}); } else { electrics.speedo3.css({fill:'white'}); }
		if(speedo<=40) { electrics.speedo4.css({fill:'transparent'}); } else { electrics.speedo4.css({fill:'white'}); }
		if(speedo<=48) { electrics.speedo5.css({fill:'transparent'}); } else { electrics.speedo5.css({fill:'white'}); }
		if(speedo<=56) { electrics.speedo6.css({fill:'transparent'}); } else { electrics.speedo6.css({fill:'white'}); }
		if(speedo<=64) { electrics.speedo7.css({fill:'transparent'}); } else { electrics.speedo7.css({fill:'white'}); }
		if(speedo<=72) { electrics.speedo8.css({fill:'transparent'}); } else { electrics.speedo8.css({fill:'white'}); }
		if(speedo<=80) { electrics.speedo9.css({fill:'transparent'}); } else { electrics.speedo9.css({fill:'white'}); }
		if(speedo<=88) { electrics.speedo10.css({fill:'transparent'}); } else { electrics.speedo10.css({fill:'white'}); }
		if(speedo<=96) { electrics.speedo11.css({fill:'transparent'}); } else { electrics.speedo11.css({fill:'white'}); }
		if(speedo<=104) { electrics.speedo12.css({fill:'transparent'}); } else { electrics.speedo12.css({fill:'white'}); }
		if(speedo<=112) { electrics.speedo13.css({fill:'transparent'}); } else { electrics.speedo13.css({fill:'white'}); }
		if(speedo<=120) { electrics.speedo14.css({fill:'transparent'}); } else { electrics.speedo14.css({fill:'white'}); }
		if(speedo<=128) { electrics.speedo15.css({fill:'transparent'}); } else { electrics.speedo15.css({fill:'white'}); }
		if(speedo<=136) { electrics.speedo16.css({fill:'transparent'}); } else { electrics.speedo16.css({fill:'white'}); }
		if(speedo<=144) { electrics.speedo17.css({fill:'transparent'}); } else { electrics.speedo17.css({fill:'white'}); }
		if(speedo<=152) { electrics.speedo18.css({fill:'transparent'}); } else { electrics.speedo18.css({fill:'white'}); }
		if(speedo<=160) { electrics.speedo19.css({fill:'transparent'}); } else { electrics.speedo19.css({fill:'white'}); }
		if(speedo<=168) { electrics.speedo20.css({fill:'transparent'}); } else { electrics.speedo20.css({fill:'white'}); }
		if(speedo<=176) { electrics.speedo21.css({fill:'transparent'}); } else { electrics.speedo21.css({fill:'white'}); }
		if(speedo<=184) { electrics.speedo22.css({fill:'transparent'}); } else { electrics.speedo22.css({fill:'white'}); }
		if(speedo<=192) { electrics.speedo23.css({fill:'transparent'}); } else { electrics.speedo23.css({fill:'white'}); }
		if(speedo<=200) { electrics.speedo24.css({fill:'transparent'}); } else { electrics.speedo24.css({fill:'white'}); }
		if(speedo<=208) { electrics.speedo25.css({fill:'transparent'}); } else { electrics.speedo25.css({fill:'white'}); }
		if(speedo<=216) { electrics.speedo26.css({fill:'transparent'}); } else { electrics.speedo26.css({fill:'white'}); }
		if(speedo<=224) { electrics.speedo27.css({fill:'transparent'}); } else { electrics.speedo27.css({fill:'white'}); }
		if(speedo<=232) { electrics.speedo28.css({fill:'transparent'}); } else { electrics.speedo28.css({fill:'white'}); }
		if(speedo<=240) { electrics.speedo29.css({fill:'transparent'}); } else { electrics.speedo29.css({fill:'white'}); }
		if(speedo<=248) { electrics.speedo30.css({fill:'transparent'}); } else { electrics.speedo30.css({fill:'white'}); }
		if(speedo<=256) { electrics.speedo31.css({fill:'transparent'}); } else { electrics.speedo31.css({fill:'white'}); }
		if(speedo<=264) { electrics.speedo32.css({fill:'transparent'}); } else { electrics.speedo32.css({fill:'white'}); }
		if(speedo<=272) { electrics.speedo33.css({fill:'transparent'}); } else { electrics.speedo33.css({fill:'white'}); }
		if(speedo<=280) { electrics.speedo34.css({fill:'transparent'}); } else { electrics.speedo34.css({fill:'white'}); }
		if(speedo<=288) { electrics.speedo35.css({fill:'transparent'}); } else { electrics.speedo35.css({fill:'white'}); }
		if(speedo<=296) { electrics.speedo36.css({fill:'transparent'}); } else { electrics.speedo36.css({fill:'white'}); }
		if(speedo<=304) { electrics.speedo37.css({fill:'transparent'}); } else { electrics.speedo37.css({fill:'white'}); }
		if(speedo<=312) { electrics.speedo38.css({fill:'transparent'}); } else { electrics.speedo38.css({fill:'white'}); }
		if(speedo<=320) { electrics.speedo39.css({fill:'transparent'}); } else { electrics.speedo39.css({fill:'white'}); }
		if(speedo<=328) { electrics.speedo40.css({fill:'transparent'}); } else { electrics.speedo40.css({fill:'white'}); }
		if(speedo<=336) { electrics.speedo41.css({fill:'transparent'}); } else { electrics.speedo41.css({fill:'white'}); }
		if(speedo<=344) { electrics.speedo42.css({fill:'transparent'}); } else { electrics.speedo42.css({fill:'white'}); }
		if(speedo<=352) { electrics.speedo43.css({fill:'transparent'}); } else { electrics.speedo43.css({fill:'white'}); }
    }

    function updateOilTemp(data) {
      let val = data.electrics.oiltemp -50;
      //min 50C, max 140 C, useing metric cause lazy
    }

    function updateClockDisplay(data) {
      gauge.clock.text(data.customModules.environmentData.time);
    }

    function updateBattery(data) {
      let val = (data.electrics.engineRunning>0.5)? 14.5: 12.5;//fake voltage
      //min 8, max 16 V
    }

    // overwriting plain javascript function so we can access from within the controller
    $window.setup = (data) => {
      if(!ready){
        console.log("calling setup while svg not fully loaded");
        setTimeout(function(){ $window.setup(data) }, 100);
        return;
      }

      //console.log("setup",data);

    }


    function setElec(val, state, key){
      if( val === undefined || val === null){console.error("setElec: svg element not found", key); return;}
      if( state === undefined || state === null){console.error("setElec: state not found", key);val.n.style.display = "white"; return;}
      var cssState = (state===true || state>0.1)?"inline":"white";
      //val.n.setAttribute("opacity", (state || state>0.1)?1.0:0.3)
    }


    $window.updateData = (data) => {
      if (data) {
        if(!ready){console.log("not ready");return;}
        // console.log(data);

        // Update PRNDS display
        // Update Speed displays
        updateSpeedDisplays(data);
		updateIndicatorLightsDisplay(data);
		updateSignalsDisplay(data);
        updateClockDisplay(data);
        updateBiegDisplays(data);

        updateTachoDisplays(data);
        updateSpeedoDisplays(data);
		
        updateGagueFuel(data);
        updateGagueTempDisplays(data);
        updateOilTemp(data);
        updateBattery(data);
      }
    }
    //ready = true;
  });